Index: tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java
===================================================================
--- tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java	(revision 541)
+++ tmp/org.txm.concordance.rcp/src/org/txm/concordance/rcp/editors/ConcordanceEditor.java	(revision 542)
@@ -1649,7 +1454,7 @@
 	 * @return the available sort properties
 	 */
 	public List<Property> getAvailableSortProperties() {
-		return availableKeywordSortProperties;
+		return concordance.getAvailableKeywordSortProperties();
 	}
 
 	/**
@@ -1695,7 +1500,7 @@
 	 * @return the top line
 	 */
 	public int getTopLine() {
-		return topLine;
+		return concordance.getTopIndex();
 	}
 
 	/**
@@ -1704,7 +1509,7 @@
 	 * @return the bottom line
 	 */
 	public int getBottomLine() {
-		return bottomLine;
+		return concordance.getTopIndex() + concordance.getNLinePerPage() - 1;
 	}
 
 	/**
@@ -1713,7 +1518,7 @@
 	 * @return the left context size
 	 */
 	public int getLeftContextSize() {
-		return leftContextSize;
+		return concordance.getLeftContextSize();
 	}
 
 	/**
@@ -1722,7 +1527,7 @@
 	 * @return the right context size
 	 */
 	public int getRightContextSize() {
-		return rightContextSize;
+		return concordance.getRightContextSize();
 	}
 
 	/**
@@ -1731,7 +1536,7 @@
 	 * @return the corpus
 	 */
 	public Corpus getCorpus() {
-		return corpus;
+		return concordance.getCorpus();
 	}
 
 	/* (non-Javadoc)
@@ -1747,31 +1552,16 @@
 	 * refresh column display accordingly to the views properties.
 	 */
 	private void refreshViewProperties() {
-		if (concordance != null) {
-			concordance.setViewProperties(
-					selectedLeftViewProperties,
-					selectedRightViewProperties,
-					selectedKeywordViewProperties);
+			concordance.resetLines();
 			sort();
-			//fillDisplayArea(topLine, bottomLine);
-		}
 	}
 
 	/**
 	 * Refresh sort properties.
 	 */
 	private void refreshSortProperties() {
-		if (concordance != null) {
-			try {
-				concordance.setLeftAnalysisProperties(selectedLeftSortProperties);
-				concordance.setRightAnalysisProperties(selectedRightSortProperties);
-				concordance.setKeywordAnalysisProperties(selectedKeywordSortProperties);
-			} catch (Exception e) {
-				System.err.println(NLS.bind(
-						Messages.ERROR_WHILE_LOADING_CONCORDANCE_LINE, e));
-			}
+			concordance.resetLines();
 			sort();
-		}
 	}
 
 	/**
@@ -1780,7 +1570,7 @@
 	 * @param selectedViewProperties the new left c view properties
 	 */
 	public void setLeftViewProperties(List<Property> selectedViewProperties) {
-		this.selectedLeftViewProperties = selectedViewProperties;
+		concordance.setLeftViewProperties(selectedViewProperties);
 		refreshViewProperties();
 	}
 
@@ -1790,7 +1580,7 @@
 	 * @param selectedViewProperties the new right c view properties
 	 */
 	public void setRightViewProperties(List<Property> selectedViewProperties) {
-		this.selectedRightViewProperties = selectedViewProperties;
+		concordance.setRightViewProperties(selectedViewProperties);
 		refreshViewProperties();
 	}
 
@@ -1800,7 +1590,7 @@
 	 * @param selectedViewProperties the new keyword view properties
 	 */
 	public void setKeywordViewProperties(List<Property> selectedViewProperties) {
-		this.selectedKeywordViewProperties = selectedViewProperties;
+		concordance.setKeywordViewProperties(selectedViewProperties);
 		refreshViewProperties();
 		updateViewPropertiesLabel();
 	}
@@ -1810,13 +1600,7 @@
 	 */
 	public void refreshReferenceColumnTitle()
 	{
-		if (refViewPattern == null) {
-			referenceColumn.setText(Messages.ConcordancesEditor_1);
-		} else if (refViewPattern.getProperties().size() == 0) {
-			referenceColumn.setText(Messages.ConcordancesEditor_1);
-		} else {
-			referenceColumn.setText(refViewPattern.getTitle());
-		}
+		referenceColumn.setText(concordance.getRefViewPattern().getTitle());
 	}
 
 	/**
@@ -1825,7 +1609,7 @@
 	 * @return the selected left c view properties
 	 */
 	public List<Property> getSelectedLeftViewProperties() {
-		return this.selectedLeftViewProperties;
+		return concordance.getLeftViewProperties();
 	}
 
 	/**
@@ -1834,7 +1618,7 @@
 	 * @return the selected keyword view properties
 	 */
 	public List<Property> getSelectedKeywordViewProperties() {
-		return this.selectedKeywordViewProperties;
+		return concordance.getKeywordViewProperties();
 	}
 
 	/**
@@ -1843,7 +1627,7 @@
 	 * @return the selected right c view properties
 	 */
 	public List<Property> getSelectedRightViewProperties() {
-		return this.selectedRightViewProperties;
+		return concordance.getRightViewProperties();
 	}
 
 	/**
@@ -1852,7 +1636,7 @@
 	 * @return the selected left c sort properties
 	 */
 	public List<Property> getSelectedLeftSortProperties() {
-		return this.selectedLeftSortProperties;
+		return concordance.getLeftAnalysisProperties();
 	}
 
 	/**
@@ -1861,7 +1645,7 @@
 	 * @return the selected keyword sort properties
 	 */
 	public List<Property> getSelectedKeywordSortProperties() {
-		return this.selectedKeywordSortProperties;
+		return concordance.getKeywordAnalysisProperties();
 	}
 
 	/**
@@ -1870,7 +1654,7 @@
 	 * @return the selected right c sort properties
 	 */
 	public List<Property> getSelectedRightSortProperties() {
-		return this.selectedRightSortProperties;
+		return concordance.getRightAnalysisProperties();
 	}
 
 	/**
@@ -1879,7 +1663,7 @@
 	 * @return the available left c view properties
 	 */
 	public List<Property> getAvailableLeftViewProperties() {
-		return availableLeftViewProperties;
+		return concordance.getAvailableLeftViewProperties();
 	}
 
 	/**
@@ -1888,7 +1672,7 @@
 	 * @return the available keyword view properties
 	 */
 	public List<Property> getAvailableKeywordViewProperties() {
-		return availableKeywordViewProperties;
+		return concordance.getAvailableKeywordViewProperties();
 	}
 
 	/**
@@ -1897,7 +1681,7 @@
 	 * @return the available right c view properties
 	 */
 	public List<Property> getAvailableRightViewProperties() {
-		return availableRightViewProperties;
+		return concordance.getAvailableRightViewProperties();
 	}
 
 	/**
@@ -1906,7 +1690,7 @@
 	 * @return the available left sort properties
 	 */
 	public List<Property> getAvailableLeftSortProperties() {
-		return availableLeftSortProperties;
+		return concordance.getAvailableLeftSortProperties();
 	}
 
 	/**
@@ -1915,7 +1699,7 @@
 	 * @return the available keyword sort properties
 	 */
 	public List<Property> getAvailableKeywordSortProperties() {
-		return availableKeywordSortProperties;
+		return concordance.getAvailableKeywordSortProperties();
 	}
 
 	/**
@@ -1924,7 +1708,7 @@
 	 * @return the available right sort properties
 	 */
 	public List<Property> getAvailableRightSortProperties() {
-		return availableRightSortProperties;
+		return concordance.getAvailableRightSortProperties();
 	}
 
 	/**
@@ -1933,7 +1717,7 @@
 	 * @return the selected references
 	 */
 	public List<Property> getSelectedViewReferences() {
-		return refViewPattern.getProperties();
+		return concordance.getRefViewPattern().getProperties();
 	}
 
 	/**
@@ -1942,7 +1726,7 @@
 	 * @return the selected references
 	 */
 	public List<Property> getSelectedSortReferences() {
-		return refSortPattern.getProperties();
+		return concordance.getRefAnalysePattern().getProperties();
 	}
 
 	/**
@@ -2091,7 +1875,7 @@
 	 * @return
 	 */
 	public int getPagesCount()	{
-		return (int) Math.ceil(((double)this.concordance.getNLines() / this.nLinePerPage));
+		return (int) Math.ceil(((double)this.concordance.getNLines() / concordance.getNLinePerPage()));
 	}
 
 	public void setQuery(String query) {
@@ -2126,7 +1910,7 @@
 
 		// Last resort edition
 		try {
-			InternalView iview = new InternalView(corpus);
+			InternalView iview = new InternalView(concordance.getCorpus());
 			iview.setParameters(concordance.getKeywordAnalysisProperties(), 
 					concordance.getCorpus().getStructuralUnit("text"),
 					new ArrayList<StructuralUnitProperty>(), null);
@@ -2159,49 +1943,49 @@
 	}
 
 	public void resetLeftTableColumnWidths() {
-		
+
 		int refMax = referenceColumn.getText().length();
 		for (TableItem item : viewer2.getTable().getItems()) {
 			if (refMax < item.getText(0).length()) refMax = item.getText(0).length();
 		}
-		
+
 		//System.out.println("Size="+queryLabel.getSize().x +" label="+queryLabel.getText()+" l size"+ queryLabel.getText().length());
 		float W = 1f+(float)(queryLabel.getSize().x / (float)queryLabel.getText().length());
 		//System.out.println("W= "+W+" Maxs "+refMax+ " " +leftMax+" " +keywordMax+" "+rightMax);
-		
+
 		((FormData) sash.getLayoutData()).left = new FormAttachment(0, 25+(int) (refMax*W));
 		referenceColumn.setWidth(2*(int) (refMax*W));
 		displayArea.layout(true, true);
 	}
-	
+
 	/*
 	 * 
 	 */
 	public void resetRightTableColumnWidths() {
-		
+
 		float W = 1f+(float)(queryLabel.getSize().x / (float)queryLabel.getText().length());
-		
+
 		TableColumn[] columns = viewer.getTable().getColumns();
 		for (int i = 0 ; i < columns.length ; i++) {
 			TableColumn column = columns[i];
 			if (column.getWidth() == 0) continue; // skip closed columns
-			
+
 			int max = column.getText().length();
 			if (max == 0) continue; // skip no-title columns
-			
+
 			int n = 0;
 			for (TableItem item : viewer.getTable().getItems()) {
 				if (max < item.getText(i).length()) max = item.getText(i).length();
 				if (n++ > 100) break; // stop testing after 100 lines
 			}
-			
+
 			column.setWidth(15+(int) (max*W));
 		}
 
 		viewer.getTable().layout(true, true);
 		tableResizeListener.handleEvent(null); // center on keyword column
 	}
-	
+
 	/**
 	 * Computes the column widths using the max length of each column (title+lines)
 	 * 
@@ -2219,101 +2003,15 @@
 		return this.concordance.getParent().getName().equals(parent.getName());
 	}
 
-
-
-	protected void initializeFields() {
-		if (this.concordance == null) {
-			leftContextSize = TXMPreferences.getInt(ConcordancePreferences.LEFT_CONTEXT_SIZE, ConcordancePreferences.PREFERENCES_NODE);
-			rightContextSize = TXMPreferences.getInt(ConcordancePreferences.RIGHT_CONTEXT_SIZE, ConcordancePreferences.PREFERENCES_NODE);
-
-			selectedLeftViewProperties = new ArrayList<Property>();
-			selectedRightViewProperties = new ArrayList<Property>();
-			selectedKeywordViewProperties = new ArrayList<Property>();
-
-			//set default view property
-			Property defaultViewProperty = availableKeywordViewProperties.get(0);
-			if(!defaultViewProperty.getName().equals("word")) //$NON-NLS-1$
-				for(int i = 0 ; i < availableKeywordViewProperties.size() ; i++ )
-					if (availableKeywordViewProperties.get(i).getName().equals("word")) //$NON-NLS-1$
-					{
-						defaultViewProperty = availableKeywordViewProperties.get(i);
-						break;
-					}
-
-			availableKeywordViewProperties.remove(defaultViewProperty);
-			availableLeftViewProperties.remove(defaultViewProperty);
-			availableRightViewProperties.remove(defaultViewProperty);
-			selectedLeftViewProperties.add(defaultViewProperty);
-			selectedRightViewProperties.add(defaultViewProperty);
-			selectedKeywordViewProperties.add(defaultViewProperty);
-
-			//set default sort property
-			selectedLeftSortProperties = new ArrayList<Property>();
-			selectedRightSortProperties = new ArrayList<Property>();
-			selectedKeywordSortProperties = new ArrayList<Property>();
-
-			Property defaultSortProperty = availableKeywordSortProperties.get(0);
-			if(!defaultSortProperty.getName().equals("word")) //$NON-NLS-1$
-				for(int i = 0 ; i < availableKeywordSortProperties.size() ; i++ )
-					if (availableKeywordSortProperties.get(i).getName().equals("word")) //$NON-NLS-1$
-					{
-						defaultSortProperty = availableKeywordSortProperties.get(i);
-						break;
-					}
-
-			availableKeywordSortProperties.remove(defaultSortProperty);
-			availableLeftSortProperties.remove(defaultSortProperty);
-			availableRightSortProperties.remove(defaultSortProperty);
-			selectedLeftSortProperties.add(defaultSortProperty);
-			selectedRightSortProperties.add(defaultSortProperty);
-			selectedKeywordSortProperties.add(defaultSortProperty);
-
-			this.refViewPattern = new ReferencePattern();
-			this.refSortPattern = new ReferencePattern();
-			try { // set the default reference is there is one
-				if (corpus.getProperty("ref") != null) //$NON-NLS-1$
-				{
-					refViewPattern.addProperty(corpus.getProperty("ref")); //$NON-NLS-1$
-					refSortPattern.addProperty(corpus.getProperty("ref")); //$NON-NLS-1$
-				} else {
-					if (corpus.getStructuralUnit("text") != null) //$NON-NLS-1$
-						if (corpus.getStructuralUnit("text").getProperty("id") != null) //$NON-NLS-1$ //$NON-NLS-2$
-						{
-							refViewPattern.addProperty(corpus.getStructuralUnit("text").getProperty("id")); //$NON-NLS-1$ //$NON-NLS-2$
-							refSortPattern.addProperty(corpus.getStructuralUnit("text").getProperty("id")); //$NON-NLS-1$ //$NON-NLS-2$
-						}
-				}
-			} catch (CqiClientException e) {
-				System.out.println(NLS.bind(Messages.ConcordancesEditor_43, corpus.getName(), e));
-			}
-		} else {
-			leftContextSize = concordance.getLeftContextSize();
-			rightContextSize = concordance.getRightContextSize();
-
-			selectedLeftViewProperties = concordance.getLeftViewProperties();
-			selectedRightViewProperties = concordance.getRightViewProperties();
-			selectedKeywordViewProperties = concordance.getKeywordViewProperties();
-			availableKeywordViewProperties.remove(selectedKeywordViewProperties);
-			availableLeftViewProperties.remove(selectedLeftViewProperties);
-			availableRightViewProperties.remove(selectedRightViewProperties);
-
-			selectedLeftSortProperties = concordance.getLeftAnalysisProperties();
-			selectedRightSortProperties = concordance.getRightAnalysisProperties();
-			selectedKeywordSortProperties = concordance.getKeywordAnalysisProperties();
-			availableKeywordSortProperties.remove(selectedKeywordSortProperties);
-			availableLeftSortProperties.remove(selectedLeftSortProperties);
-			availableRightSortProperties.remove(selectedRightSortProperties);
-
-			this.refViewPattern = concordance.getRefViewPattern();
-			this.refSortPattern = concordance.getRefAnalysePattern();
-		}
+	@Override public Concordance getResultData() {
+		return concordance;
 	}
 
 	public Composite getExtensionButtonComposite() {
 		// TODO Auto-generated method stub
 		return null;
 	}
-	
+
 	/**
 	 * ControlerListener to maintain the width of a TableColumn superior to 5
 	 * 
Index: tmp/org.txm.referencer.rcp/src/org/txm/rcp/editors/referencer/ReferencerEditor.java
===================================================================
--- tmp/org.txm.referencer.rcp/src/org/txm/rcp/editors/referencer/ReferencerEditor.java	(revision 541)
+++ tmp/org.txm.referencer.rcp/src/org/txm/rcp/editors/referencer/ReferencerEditor.java	(revision 542)
@@ -174,14 +174,6 @@
 	}
 
 	/* (non-Javadoc)
-	 * @see org.eclipse.ui.part.EditorPart#isDirty()
-	 */
-	@Override
-	public boolean isDirty() {
-		return referencer.isDirty();
-	}
-
-	/* (non-Javadoc)
 	 * @see org.eclipse.ui.part.EditorPart#isSaveAsAllowed()
 	 */
 	@Override
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Corpus.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Corpus.java	(revision 541)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/corpus/Corpus.java	(revision 542)
@@ -1320,6 +1320,10 @@
 	}
 	
 	HashMap<Class, HashSet<Object>> storedData = new HashMap<Class, HashSet<Object>>();
+
+	private StructuralUnit textStructuralUnit;
+
+	private StructuralUnitProperty textIdStructuralUnitProperty;
 	public HashSet<Object> getStoredData(Class class1) {
 		
 		if (!storedData.containsKey(class1))
@@ -1352,4 +1356,16 @@
 		}
 		return false;
 	}
+	
+	public StructuralUnit getTextStructuralUnit() throws CqiClientException {
+		if (textStructuralUnit == null)
+			textStructuralUnit = getStructuralUnit(TEXT);
+		return textStructuralUnit;
+	}
+	
+	public StructuralUnitProperty getTextIdStructuralUnitProperty() throws CqiClientException {
+		if (textIdStructuralUnitProperty == null)
+			textIdStructuralUnitProperty = getTextStructuralUnit().getProperty(ID);
+		return textIdStructuralUnitProperty;
+	}
 }
Index: tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/ReferencePattern.java
===================================================================
--- tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/ReferencePattern.java	(revision 541)
+++ tmp/org.txm.searchengine.cqp.core/src/org/txm/searchengine/cqp/ReferencePattern.java	(revision 542)
@@ -131,6 +131,9 @@
 	 * @return the title
 	 */
 	public String getTitle() {
+		if (this.properties == null) return "none";
+		else if (this.properties.size() == 0) return "none";
+		
 		String title = ""; //$NON-NLS-1$
 		for(Property p : this.properties)
 			if (p instanceof StructuralUnitProperty)
